// --------------------------------------------------------------------------------------------------
function AAData(domain, type, description, alternative) {
  this.domain = domain.toLowerCase();
  this.type = type;
  this.description = description;
  this.alternative = Number(alternative);
}
// --------------------------------------------------------------------------------------------------
function AADataCompare(data1, data2) {
  var len1 = data1.domain.split(/\./).length;
  var len2 = data2.domain.split(/\./).length;
  if (len1 < len2)
    return 1;
  if (len1 == len2)
    return 0;
  return -1;
}
// --------------------------------------------------------------------------------------------------
var computerbildabzockschutz = {
  onLoad : function() {
    // initialization code
    this.ID = '{d49175b3-3fd8-43b8-b28e-da5d47f3c398}';
    this.initialized = true;
    this.strings = document.getElementById('computerbildabzockschutz-strings');
    // the urls
    this.baseURL = 'http://www.computerbild.de/';
    this.infoURL = this.baseURL + 'internet-abzocke/uebersicht'; // infos über
                                                                  // abzock-maschen
    this.reportURL = this.baseURL + 'internet-abzocke/seite-melden'; // abzock-zeite
                                                                      // melden
    this.dbsearchURL = this.baseURL + 'internet-abzocke'; // datenbank
                                                          // durchsuchen
    this.cobiURL = this.baseURL + 'internet-abzocke/bewertungskriterien'; // so
                                                                          // bewertet
                                                                          // computerbild
    this.forumURL = this.baseURL + 'internet-abzocke/nutzerhilfe'; // nutzer
                                                                    // helfen
                                                                    // nutzer:
                                                                    // Forum
    this.updateURL = 'https://addons.computerbild.de/antiabzocke/data/update.php'; // sperrliste
                                                                                    // aktualisieren
    // this.updateURL = 'http://cbabzocke.j3s.de/ips.xml';
    this.nutzungsbedingungenURL = 'chrome://computerbildabzockschutz/content/pages/nutzungsbedingungen.html';

    /*this.window = null;
    this.newwindow = null;
    this.tabids = new Array();
    this.firsts = new Array();
    this.requests = new Array();
    this.requestDomains = new Array();*/
    
    // show the button
    this.showButton();
    // the domains overriden by the user (not persistent)
    //this.okdomains = new Array();
    // register web progress listener
    getBrowser().addProgressListener(this,
        Components.interfaces.nsIWebProgress.NOTIFY_ALL);
    getBrowser().tabContainer.addEventListener('TabOpen', function(e) {
      computerbildabzockschutz.onTabAdded(e);
    }, false);
    this.currentWindow().setTimeout('computerbildabzockschutz.initEngine()', 10);
  },
  // --------------------------------------------------------------------------------------------------
  initEngine: function() {
    var component = Components.classes['@computerbildabzockschutz/network/protocol;1?name=http'].createInstance().wrappedJSObject;
    //this.log('component.engine:' + component.engine);
    this.engine = component.engine;
    if (this.engine == null) {
      this.currentWindow().setTimeout('computerbildabzockschutz.initEngine()', 10);
      return;
    }
    this.engine.init(this.ID);
  },
  // --------------------------------------------------------------------------------------------------
  onUnload : function() {
    getBrowser().removeProgressListener(this);
    getBrowser().tabContainer.removeEventListener('TabOpen', this, 'false');
    window
        .removeEventListener('computerbildabzockschutzOkEvent', this, 'false');
    window.removeEventListener('computerbildabzockschutzLoadedEvent', this,
        'false');
    window.removeEventListener('computerbildabzockschutzResizedEvent', this,
        'false');
  },
  // --------------------------------------------------------------------------------------------------
  showURL : function(url) {
    var wm = Components.classes['@mozilla.org/appshell/window-mediator;1']
        .getService(Components.interfaces.nsIWindowMediator);
    var browser = wm.getMostRecentWindow('navigator:browser').getBrowser();
    browser.selectedTab = browser.addTab(url);
    if (url.indexOf('chrome://') == 0) {
      //this.currentWindow().setTimeout("document.getElementById('urlbar').value='';", 100)
      setTimeout("document.getElementById('urlbar').value='';", 100)
    }
  },
  // --------------------------------------------------------------------------------------------------
  onMenuItemCommand : function(e) {
    var name = e.target.id.split(/-/)[1];
    var url = eval('this.' + name + 'URL')
    if (name == 'update') {
      this.engine.update(true);
    } else {
      if (name == 'report') {
        // append the current url
        var text = document.getElementById('urlbar').value;
        url += '?url=' + escape(text);
      }
      this.showURL(url);
    }
  },
  // --------------------------------------------------------------------------------------------------
  showButton : function() {
    var id = 'computerbildabzockschutz-toolbar-button';
    var before = 'urlbar-container';
    var navbar = document.getElementById('nav-bar');
    if (!navbar || navbar.currentSet.indexOf(id) != -1) {
      return;
    }
    var box = document.getElementById('navigator-toolbox');
    if (!box) {
      return;
    }
    var bar = box.firstChild;
    while (bar) {
      if (bar.currentSet && bar.currentSet.indexOf(id) != -1) {
        return;
      }
      bar = bar.nextSibling;
    }
    var target = document.getElementById(before);
    var elem = navbar.firstChild;
    while (elem) {
      if (elem == target) {
        break;
      }
      elem = elem.nextSibling;
    }
    navbar.insertItem(id, elem, null, false);
    document.persist('nav-bar', 'currentset');
  },
  // --------------------------------------------------------------------------------------------------
  toggleButton : function(type) {
    /*var wm = Components.classes['@mozilla.org/appshell/window-mediator;1']
                                .getService(Components.interfaces.nsIWindowMediator);
    var win = wm.getMostRecentWindow('navigator:browser');
    */
    if (this.currentWindow().document == null) {
      return;
    }
    var el = this.currentWindow().document.getElementById('computerbildabzockschutz-toolbar-button');
    if (el != null) {
      el.style.listStyleImage = 'url("chrome://computerbildabzockschutz/skin/button-' + type + '.png")';
    }
  },
  // --------------------------------------------------------------------------------------------------
  log: function(msg) {
    try {
      var consoleService = Components.classes['@mozilla.org/consoleservice;1']
          .getService(Components.interfaces.nsIConsoleService);
      consoleService.logStringMessage(this.strings.getString('name') + ': '
          + msg);
    } catch(e) { }
  },
  // --------------------------------------------------------------------------------------------------
  getBrowserByTabId : function(tabid) {
    var browser = getBrowser();
    for ( var i = 0; i < browser.browsers.length; i++) {
      if (browser.browsers[i].parentNode.id == tabid) {
        return browser.browsers[i];
      }
    }
    var wm = Components.classes['@mozilla.org/appshell/window-mediator;1']
        .getService(Components.interfaces.nsIWindowMediator);
    return wm.getMostRecentWindow('navigator:browser').getBrowser();
  },
  // --------------------------------------------------------------------------------------------------
  loadURI : function(url, clear, tabid) {
    if (clear == null) {
      clear = true;
    }
    var browser = this.getBrowserByTabId(tabid);
    browser.loadURIWithFlags(url, nsIWebNavigation.LOAD_FLAGS_NONE, null, null,
        null);
    if (clear && url.indexOf('chrome://') == 0) {
      this.currentWindow().setTimeout("document.getElementById('urlbar').value='';", 100)
    }
  },
  // --------------------------------------------------------------------------------------------------
  checkButton : function(request, url, domain) {
    var type = 'normal';
    var idx = this.isBlocked(domain);
    if (idx != null) {
      type = this.aadata[idx].type;
    }
    this.toggleButton(type);
  },
  // --------------------------------------------------------------------------------------------------
  currentWindow: function() {
    if (this.newwindow != null) {
      return this.newwindow;
    }
    if (this.window != null) {
      return this.window;
    }
    return window;
  },
  // --------------------------------------------------------------------------------------------------
  onTabAdded : function(ev) {
    this.toggleButton('normal');
  },
  // --------------------------------------------------------------------------------------------------
  getFlagLog: function(aFlag) {
    var str = '';
    if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_START) {
      str += 'start ';
    }
    if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_REDIRECTING) {
      str += 'redirecting ';
    }
    if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_TRANSFERRING) {
      str += 'transfering ';
    }
    if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_NEGOTIATING) {
      str += 'negotiating ';
    }
    if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_STOP) {
      str += 'stop ';
    }
    if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_IS_REQUEST) {
      str += 'request ';
    }
    if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_IS_DOCUMENT) {
      str += 'document ';
    }
    if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_IS_NETWORK) {
      str += 'network ';
    }
    if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_IS_WINDOW) {
      str += 'window ';
    }
    if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_RESTORING) {
      str += 'restoring ';
    }
    return str;
  },
  // --------------------------------------------------------------------------------------------------
  QueryInterface : function(aIID) {
    if (aIID.equals(Components.interfaces.nsISupportsWeakReference)
        || aIID.equals(Components.interfaces.nsIWebProgressListener)
        || aIID.equals(Components.interfaces.nsISupports))
      return this;
    throw Components.results.NS_NOINTERFACE;
  },

  onStateChange: function(aWebProgress, aRequest, aFlag, aStatus) {
   if(aFlag & Components.interfaces.nsIWebProgressListener.STATE_START) {
     this.toggleButton('normal');
   }
   if(aFlag & Components.interfaces.nsIWebProgressListener.STATE_STOP) {
     //this.log('onStateChange: ' + document.getElementById('urlbar').value);
     if (this.engine == null) {
       return;
     }
     var domain = this.engine.extractDomain(document.getElementById('urlbar').value);
     var blocked = this.engine.isBlocked(domain);
     if (blocked != null) {
       this.toggleButton(this.engine.getType(blocked));
     }
   }
  },
  onLocationChange: function(aProgress, aRequest, aURI) { 
    //this.log('onLocationChange: ' + document.getElementById('urlbar').value);
    if (this.engine == null) {
      return;
    }
    var domain = this.engine.extractDomain(document.getElementById('urlbar').value);
    var blocked = this.engine.isBlocked(domain);
    if (blocked != null) {
      this.toggleButton(this.engine.getType(blocked));
    } else {
      this.toggleButton('normal');
    }
  },
  onProgressChange: function(aWebProgress, aRequest, curSelf, maxSelf, curTot, maxTot) { },
  onStatusChange: function(aWebProgress, aRequest, aStatus, aMessage) { },
  onSecurityChange: function(aWebProgress, aRequest, aState) { },

// --------------------------------------------------------------------------------------------------

  // This code was written by Tyler Akins and has been placed in the
  // public domain. It would be nice if you left this header intact.
  // Base64 code from Tyler Akins -- http://rumkin.com
  encode64 : function(input) {
    // hell of secure:
  input = '' + input;
  var keyStr = 'FEDCBAGHIJKLMNOPQRSTUVWXYZfedcbaghijklmnopqrstuvwxyz0123456789+/=';
  var output = '';
  var chr1, chr2, chr3;
  var enc1, enc2, enc3, enc4;
  var i = 0;

  do {
    chr1 = input.charCodeAt(i++);
    chr2 = input.charCodeAt(i++);
    chr3 = input.charCodeAt(i++);

    enc1 = chr1 >> 2;
    enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
    enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
    enc4 = chr3 & 63;

    if (isNaN(chr2)) {
      enc3 = enc4 = 64;
    } else if (isNaN(chr3)) {
      enc4 = 64;
    }

    output = output + keyStr.charAt(enc1) + keyStr.charAt(enc2)
        + keyStr.charAt(enc3) + keyStr.charAt(enc4);
  } while (i < input.length);

  return output;
},

decode64 : function(input) {
  input = '' + input;
  // hell of secure:
  var keyStr = 'FEDCBAGHIJKLMNOPQRSTUVWXYZfedcbaghijklmnopqrstuvwxyz0123456789+/=';
  var output = '';
  var chr1, chr2, chr3;
  var enc1, enc2, enc3, enc4;
  var i = 0;

  // remove all characters that are not A-Z, a-z, 0-9, +, /, or =
  input = input.replace(/[^A-Za-z0-9\+\/\=]/g, '');

  do {
    enc1 = keyStr.indexOf(input.charAt(i++));
    enc2 = keyStr.indexOf(input.charAt(i++));
    enc3 = keyStr.indexOf(input.charAt(i++));
    enc4 = keyStr.indexOf(input.charAt(i++));

    chr1 = (enc1 << 2) | (enc2 >> 4);
    chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
    chr3 = ((enc3 & 3) << 6) | enc4;

    output = output + String.fromCharCode(chr1);

    if (enc3 != 64) {
      output = output + String.fromCharCode(chr2);
    }
    if (enc4 != 64) {
      output = output + String.fromCharCode(chr3);
    }
  } while (i < input.length);

  return output;
}
};
// --------------------------------------------------------------------------------------------------
window.addEventListener('load', function(e) {
  computerbildabzockschutz.onLoad(e);
}, false);
window.addEventListener('unload', function(e) {
  computerbildabzockschutz.onUnload(e);
}, false);
