//-----------------------------------------------------------------------------------------------------------------------
// url - the url
//-----------------------------------------------------------------------------------------------------------------------
function showInNewTab(url) {
  var wm = Components.classes['@mozilla.org/appshell/window-mediator;1']
                              .getService(Components.interfaces.nsIWindowMediator);
  var browser = wm.getMostRecentWindow('navigator:browser').getBrowser();
  browser.selectedTab = browser.addTab(url);
}
//-----------------------------------------------------------------------------------------------------------------------
// email - the email address
// subject - the subject (optional)
// body - the body (optional)
//-----------------------------------------------------------------------------------------------------------------------
function mailTo(email, subject, body) {
  var wm = Components.classes['@mozilla.org/appshell/window-mediator;1']
                              .getService(Components.interfaces.nsIWindowMediator);
  var browser = wm.getMostRecentWindow('navigator:browser').getBrowser();
  var url = 'mailto:' + email;
  if (subject != null) {
    url += '?subject='+subject;
  }
  if (body != null) {
    url += '&body='+body;
  }
  browser.loadURI(url, browser.LOAD_FLAGS_NONE, null, null, null);
}
//-----------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------
function isWin() {
  return (navigator.platform.toLowerCase().indexOf('win') == 0);
}
//-----------------------------------------------------------------------------------------------------------------------
// binary - the binary to execute (must be on the path if not given fully qualified)
// args - an array of arguments (optional)
//-----------------------------------------------------------------------------------------------------------------------
function executeBinary(binary, args) {
  var aFile = null;
  try {
    aFile = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
    aFile.initWithPath(binary);
  } catch(e) {
    aFile = null;
  }
    
  if (aFile == null || !aFile.exists()) { // try to resolve by PATH environment variable
    var env = Components.classes['@mozilla.org/process/environment;1'].getService(Components.interfaces.nsIEnvironment);
    var envPath = env.get('PATH');
    var entries = null;
    if (isWin()) { entries = envPath.split(';'); } else { entries = envPath.split(':'); }
    for (var i = 0; i < entries.length; i++) {
      aFile = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
      aFile.initWithPath(entries[i]);
      aFile.append(binary);
      if (aFile.exists()) {
        break;
      }
    }
  }
  if (aFile == null) {
    alert('Can\'t find '+binary+' in path');
    return;
  }
  var aProcess = Components.classes['@mozilla.org/process/util;1'].getService(Components.interfaces.nsIProcess); 
  aProcess.init(aFile);
  if (args == null) {
    args = new Array();
  }
  aProcess.run(false,args,args.length);
}
//-----------------------------------------------------------------------------------------------------------------------
// win - the window
// name - the frame name
//-----------------------------------------------------------------------------------------------------------------------
function findFrame(win, name) {
  for (var i = 0; i < win.frames.length; i++) {
    if (win.frames[i].name == name) {
      return win.frames[i];
    }
  }
  return null;
}
//-----------------------------------------------------------------------------------------------------------------------
// form - the form
// name - the element name
//-----------------------------------------------------------------------------------------------------------------------
function findFormElement(form, name) {
  var els = form.elements;
  for (var i = 0; i < els.length; i++) {
    if (els[i].name == name) {
      return els[i]
    }
  }
  return null;
}
//-----------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------
function convertFromUnicode(charset, str)
{
  try {
    var unicodeConverter = Components
       .classes['@mozilla.org/intl/scriptableunicodeconverter']
       .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
    unicodeConverter.charset = charset;
    str = unicodeConverter.ConvertFromUnicode(str);
    return str + unicodeConverter.Finish();
  } catch(ex) {
    return null; 
  }
}
//-----------------------------------------------------------------------------------------------------------------------
function convertToUnicode(charset, str)
{
  try {
    var unicodeConverter = Components
       .classes['@mozilla.org/intl/scriptableunicodeconverter']
       .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
    unicodeConverter.charset = charset;
    str = unicodeConverter.ConvertToUnicode(str);
    return str + unicodeConverter.Finish();
  } catch(ex) {
    return null; 
  }
}
//-----------------------------------------------------------------------------------------------------------------------
function getExtensionVersion(extensionid) {
  var em = Components.classes['@mozilla.org/extensions/manager;1'].getService(Components.interfaces.nsIExtensionManager);  
  var addon = em.getItemForID(extensionid);  
  return addon.version;
}
//-----------------------------------------------------------------------------------------------------------------------
function getSupportedInterfaces(clazz) {
  var interfaces = new Array();
  for (var i in Components.interfaces) {
    if (i.toLowerCase().indexOf('nsi') == 0) {
      var res = null;
      var c = eval('Components.interfaces.' + i);
      try { res = clazz.getService(c); } catch(e) { }
      if (res != null) {
        interfaces.push(i);
      }
    }
  }
  return interfaces;
}