// constants
const nsISupportsWeakReference = Components.interfaces.nsISupportsWeakReference;
const nsIHttpProtocolHandler = Components.interfaces.nsIHttpProtocolHandler;
const nsIProxiedProtocolHandler = Components.interfaces.nsIProxiedProtocolHandler;
const nsIProtocolHandler = Components.interfaces.nsIProtocolHandler;
const nsIObserver = Components.interfaces.nsIObserver;
const nsISupports = Components.interfaces.nsISupports;

const CLASS_ID = Components.ID('{2a08390e-9c76-44cb-b4ff-926435712bd3}');
const CLASS_NAME = 'Interceptor';
const CONTRACT_ID = '@computerbildabzockschutz/network/protocol;1?name=http';
const LOADER = Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
                  .getService(Components.interfaces.mozIJSSubScriptLoader);

var InterceptorOriginalService = null;

//Interceptor.prototype = {
const Interceptor = {

  engine: null,

  BLACKLIST: null,
  
  REVIEW: null,
  
  AZ: null,
  
  BACK: null,
  
  ALERT: null,

  WARN: null,

  userAgent: null,
  
  appName: null,
  
  appVersion: null,
  
  vendor: null,
  
  vendorSub: null,
  
  vendorComment: null,
  
  product: null,
  
  productSub: null,
  
  productComment: null,
  
  platform: null,
  
  oscpu: null,
  
  language: null,
  
  misc: null,
  
  scheme: null,
  
  defaultPort: null,
  
  protocolFlags: null,
  
  QueryInterface: function(aIID)   {
    if (!aIID.equals(nsISupportsWeakReference) &&
        !aIID.equals(nsIHttpProtocolHandler) &&
        !aIID.equals(nsIProxiedProtocolHandler) &&
        !aIID.equals(nsIProtocolHandler) &&
        !aIID.equals(nsIObserver) &&
        !aIID.equals(nsISupports))
      throw Components.results.NS_ERROR_NO_INTERFACE;
    return this;
  },

  observe: function(subject, topic, data) {
    switch (topic) {
      case 'xpcom-startup':
        InterceptorOriginalService = Components.classes['@mozilla.org/network/protocol;1?name=http'];
        var service = InterceptorOriginalService.getService(Components.interfaces.nsIHttpProtocolHandler);
        this.userAgent = service.userAgent;
        this.appName = service.appName;
        this.appVersion = service.appVersion ;
        this.vendor = service.vendor;
        this.vendorSub = service.vendorSub;
        this.vendorComment = service.vendorComment;
        this.product = service.product;
        this.productSub = service.productSub;
        this.productComment = service.productComment;
        this.platform = service.platform;
        this.oscpu = service.oscpu;
        this.language = service.language;
        this.misc = service.misc;
        this.scheme = service.scheme;
        this.defaultPort = service.defaultPort;
        this.protocolFlags = service.protocolFlags;
        this.misc = service.misc;
        LOADER.loadSubScript('chrome://computerbildabzockschutz/content/engine.js');
        this.engine = AAEngine;
        var compMgr = Components.manager.QueryInterface(Components.interfaces.nsIComponentRegistrar);
        compMgr.registerFactory(CLASS_ID, CLASS_NAME, '@mozilla.org/network/protocol;1?name=http', InterceptorFactory);
        this.BLACKLIST = 'chrome://computerbildabzockschutz/content/pages/blacklist.html';
        this.REVIEW = 'chrome://computerbildabzockschutz/content/pages/review.html';
        this.AZ = 'chrome://computerbildabzockschutz/content/pages/az.js';
        this.BACK = 'chrome://computerbildabzockschutz/content/pages/backgrad.png';
        this.ALERT = 'chrome://computerbildabzockschutz/content/pages/alertback.png';
        this.WARN = 'chrome://computerbildabzockschutz/content/pages/warnback.png';
        break;
    }
  },
  
  getContents: function (aURL){
    var ioService=Components.classes["@mozilla.org/network/io-service;1"]
      .getService(Components.interfaces.nsIIOService);
    var scriptableStream=Components
      .classes["@mozilla.org/scriptableinputstream;1"]
      .getService(Components.interfaces.nsIScriptableInputStream);

    var channel=ioService.newChannel(aURL,'utf-8',null);
    channel.contentCharset = 'utf-8';
    var input=channel.open();
    scriptableStream.init(input);
    var str=scriptableStream.read(input.available());
    scriptableStream.close();
    input.close();
    return str;
  },

  newProxiedChannel: function(uri, proxyInfo) {
    return InterceptorOriginalService.getService(Components.interfaces.nsIProxiedProtocolHandler).newProxiedChannel(uri, proxyInfo);
  },

  newURI: function(aSpec,  aOriginCharset, aBaseURI) {
    if (aSpec.indexOf('http://:/magic:') == 0) {
      var magic = aSpec.substr(15);
      var aadata = this.engine.getData(magic);
      this.engine.setOk(this.engine.extractDomain(aadata.url));
      aSpec = aadata.url;
    }    
    return InterceptorOriginalService.getService(Components.interfaces.nsIProtocolHandler).newURI(aSpec,  aOriginCharset, aBaseURI);
  },

  getChromeChannel: function(url, uri) {
    var ioService=Components.classes["@mozilla.org/network/io-service;1"]
                                     .getService(Components.interfaces.nsIIOService);
   var scriptableStream=Components
     .classes["@mozilla.org/scriptableinputstream;1"]
     .getService(Components.interfaces.nsIScriptableInputStream);
   return ioService.newChannel(url,null,null);
  },
  
  sendData: function(data, uri) {
    var stringStream = Components.classes["@mozilla.org/io/string-input-stream;1"].createInstance(Components.interfaces.nsIStringInputStream);
    if ("data" in stringStream) { // Gecko 1.9 or newer
      stringStream.data = data;
   } else { // 1.8 or older
      stringStream.setData(data, data.length);
   }
   var channel = Components.classes["@mozilla.org/network/input-stream-channel;1"].createInstance(Components.interfaces.nsIInputStreamChannel);
   channel.setURI(uri);
   channel.contentStream = stringStream;
   return channel;
  },
  
  newChannel: function(uri) {
    var data = null;
    if (uri.spec == 'http://:/az.js') {
      data = this.AZ;
    } else if (uri.spec == 'http://:/backgrad.png') {
      data = this.BACK;
    } else if (uri.spec == 'http://:/alertback.png') {
      data = this.ALERT;
    } else if (uri.spec == 'http://:/warnback.png') {
      data = this.WARN;
    }
    if (data != null) {
      return this.getChromeChannel(data, uri);
    }
    var domain = this.engine.extractDomain(uri.spec);
    var blocked = this.engine.isBlocked(domain);
    if (blocked != null) {
      var magic = this.engine.getMagic(uri.spec, blocked);
      var type = this.engine.getType(blocked);
      if (type == 'blacklist') {
        data = this.getContents(this.BLACKLIST);
      } else {
        data = this.getContents(this.REVIEW);
      }
      var aadata = this.engine.getData(magic);
      data = data.replace(/#DOMAIN#/, domain);
      var desc = aadata.description;
      if (desc == null) {
        desc = '';
      }
      data = data.replace(/#DESCRIPTION#/, desc);
      if (aadata.alternative) {
        data = data.replace(/Mehr Infos\.\.\./,this.engine.strings.GetStringFromName('alternative'));
      }
      /*data = data.replace(/#AZ_DO#/, domain);
      data = data.replace(/#AZ_BL#/, aadata.domain);
      data = data.replace(/#AZ_UR#/, uri.spec);
      data = data.replace(/#AZ_MA#/, magic);*/
      data = data.replace(/#MORE#/, 'http://www.computerbild.de/internet-abzocke/' + aadata.domain)
      data = data.replace(/#OK#/, 'http://:/magic:' + magic);
      return this.sendData(data, uri);
    }
    return InterceptorOriginalService.getService(Components.interfaces.nsIProtocolHandler).newChannel(uri);
  },

  allowPort: function(port, scheme) {
    return InterceptorOriginalService.getService(Components.interfaces.nsIProtocolHandler).allowPort(port, scheme);
  },

};
Interceptor.wrappedJSObject = Interceptor;

// class factory
var InterceptorFactory = {
  createInstance : function(aOuter, aIID) {
    if (aOuter != null) {
        throw Components.results.NS_ERROR_NO_AGGREGATION;
    }
    if (aIID.equals(Components.interfaces.nsISupports)) {
      return Interceptor;
    }
    return (Interceptor.QueryInterface(aIID));
  }
};

// module definition (xpcom registration)
var InterceptorModule = {
  _firstTime: true,
  registerSelf: function(aCompMgr, aFileSpec, aLocation, aType) {
    if (this._firstTime) {
      this._firstTime = false;
      throw Components.results.NS_ERROR_FACTORY_REGISTER_AGAIN;
    };
    aCompMgr = aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    aCompMgr.registerFactoryLocation(CLASS_ID, CLASS_NAME, CONTRACT_ID, aFileSpec, aLocation, aType);
    var categoryService = Components.classes['@mozilla.org/categorymanager;1']
        .getService(Components.interfaces.nsICategoryManager);
    categoryService.addCategoryEntry('xpcom-startup', CLASS_NAME, CONTRACT_ID, true, false );
  },

  unregisterSelf: function(aCompMgr, aLocation, aType) {
    aCompMgr = aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    aCompMgr.unregisterFactoryLocation(CLASS_ID, aLocation);        
  },
  
  getClassObject: function(aCompMgr, aCID, aIID) {
    if (!aIID.equals(Components.interfaces.nsIFactory))
      throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

    if (aCID.equals(CLASS_ID))
      return InterceptorFactory;

    throw Components.results.NS_ERROR_NO_INTERFACE;
  },

  canUnload: function(aCompMgr) { return true; }
};

// module initialization
function NSGetModule(aCompMgr, aFileSpec) { return InterceptorModule; }
